




package common_functions;

require(Exporter);
@ISA=qw(Exporter);

use strict;
use Support;
use Gtk;
use vars qw ( @EXPORT );
# export functions
@EXPORT = qw ( constraintsDlg );



# the data floder
#     where all data files are stored
#     this is the parent folder for :
#                          PAF folder
#                          <queue_name>.dat 
#                          ...  
my $ibmDataDir = '/etc/ibmlp/data';

# PAF folder
my $ibmPafDir = "${ibmDataDir}/pafs";

# the object which contains the translated messages
my $transObj = undef; 

# files which contain messages  ( PAF format )
my $ibmMessagesPaf = "${ibmPafDir}/messages.paf";

# setup message translation
    $transObj = new Support::messages($ibmMessagesPaf);


sub constraintsDlg {
    
######
#         THE PARAMETERS
#
	
    if ( @_ < 3 ) {
	die ("Error  :file ",__FILE__,":line ",
	     __LINE__," :function requires 3 parameter(s) .\n");
    }

    my $languageObject=shift;
    my $printerObject=shift;
    my $constraintHash=shift;
    
######
#         DEFINE THE CONTAINTER WINDOW
#
    my $window = new Gtk::Window('toplevel');
    $window->set_title($transObj->translate("MSG_ERROR"));
    $window->signal_connect("destroy",sub { destroy $window } );
    $window->set_position('center');
    $window->set_modal(1);
    $window->show;       
    $window->set_default_size(350,150);


######
#        CREATE THE V. BOX THAT CONTAINS ALL CONTROLS
#
    my $topBox = new Gtk::VBox(0,2);
    $window->add($topBox);
    $topBox->show;
    $topBox->set_border_width(20);

######
#        CREATE ERROR MESSAGE LABELS
#

    my $errorMessageTitle = new Gtk::Label($transObj->translate("CONSTR_Dlg_Label"));

    $errorMessageTitle->show;
    # add to the top Box
    $topBox->pack_start($errorMessageTitle,1,1,1);

    my $errorMessage = new Gtk::Label("");
    $errorMessage->show;
    # add to the top Box
    $topBox->pack_start($errorMessage,1,1,1);

    # get the translation of the feature 1
    my $feature1= $constraintHash->{f1};
    my $translatedFeature1=$printerObject->getFeatureTranslation($feature1);
    # get the translation of the option 1
    my $option1=$constraintHash->{o1};
    my $translatedOption1=$printerObject->getFeatureOptionTranslation($feature1,$option1);
    # construct the left message and label
    my $leftMessage = "[ ".$translatedFeature1." : ".$translatedOption1." ]";
    my $leftSideMessage = new Gtk::Label($leftMessage);
    $leftSideMessage->show;

    # construct the mid message  and label
    my $midMessage  = $transObj->translate("CONSTR_Dlg_Message");

    my $midSideMessage = new Gtk::Label( $midMessage);
    $midSideMessage->show;

    # get the translation of the feature 2
    my $feature2= $constraintHash->{f2};
    my $translatedFeature2=$printerObject->getFeatureTranslation($feature2);
    # get the translation of the option 2
    my $option2=$constraintHash->{o2};
    my $translatedOption2=$printerObject->getFeatureOptionTranslation($feature2,$option2);
    # construct the left message and label
    my $rightMessage = "[ ".$translatedFeature2." : ".$translatedOption2." ]";
    my $rightSideMessage = new Gtk::Label($rightMessage);
    $rightSideMessage->show;


######
#            CREATE THE H. BOX FOR THE ERROR DESCRIPTION
#
#
    my $constraintBox = new Gtk::HBox(0,5);
    $constraintBox->show;
    $constraintBox->pack_start($leftSideMessage,1,1,2);
    $constraintBox->pack_start($midSideMessage,1,1,10);
    $constraintBox->pack_start($rightSideMessage,1,1,2);
    # add to the top Box
    $topBox->pack_start($constraintBox,1,1,5);

######
#
#             CREATE THE OK BUTTON
#
    my $buttonBox = new Gtk::HBox(1,2);
    $buttonBox->show;
    my $okButton = new Gtk::Button("  ".$transObj->translate("ok")."  ");
    $okButton->show;
    $buttonBox->pack_start($okButton,0,0,2);
    $okButton->signal_connect("clicked",sub{$window->destroy});
#   add the button box to the top level H. Box
    $topBox->pack_end($buttonBox,1,1,5);



}

1;














